#ifndef TTY_H
#define TTY_H

#include <a4c/iome.h>
#include <a4c/starwin.h>
#include <a4c/a4c.tk.h>
#include <dlfcn.h>

#define a4cRECT  swRect
#define a4cCOLOR swCOLOR
typedef void * a4cHANDLE;
typedef char * a4cString;

typedef struct {
  a4cRECT Border;
  a4cRECT Text;
  int style;
  char *message;
  int len;
} a4cKeyBox;

typedef struct {
  int row;
  int col;
  swRect Panel;
  swRect Scroll;
  swRect Term;
  
  swRect Menu;
  int logo_w,logo_h;
  unsigned char * logo;

  a4cKeyBox ListArea;
  a4cKeyBox KeyArea;
  a4cKeyBox Method;
  a4cKeyBox Charset;
  a4cKeyBox FontSize;

  a4cCOLOR fgcolor;
  a4cCOLOR bgcolor;
  a4cCOLOR egcolor;

  char ptyname[32];
  swTerminal * TERM;
  int pty;
  fd_set ptyset,rptyset;

  char * VideoMode;
  
  /************************\
          Configure
  \************************/
  iomeDefaultConf CONF;
  iomeConfig      CFG;
  char ** modelists;
  char * dev_mouse;
  char * dev_console;

  /*************************\
        Module Handler
  \*************************/  
  char * base_charset;
  char * current_charset;
  char * neutral_charset;

  int dl_handles;
  a4cHANDLE * SO_HANDLES;

  int           method_size;
  int           current_method;
  int           last_method;
  iomeModule *  METHOD_NOW;
  iomeModule ** METHOD;
  char *        METHOD_ENGLISH;
  
  int           filter_size;
  int           current_filter;
  int           last_filter;
  iomeModule *  FILTER_NOW;
  iomeModule ** FILTER;
  char *        FILTER_NEUTRAL;

  iomeEncoding  CC;

  /**************************\
           Font Size
  \**************************/
  int fontsize;
  a4cString fontsize_name[2];
  
} ttyDime;

#define A4C_STYLE_NORMAL   0
#define A4C_STYLE_NOBORDER 1
#define A4C_STYLE_CENTER   2

#define A4C_METHOD_LENGTH 5
#define A4C_FONTSIZE_LENGTH 2
#define A4C_CHARSET_LENGTH 3
extern int A4C_KEYAREA_LENGTH;

int ttyCalcResolution(ttyDime * DIM);
int isInKeyBox(int x,int y,a4cKeyBox * KEYBOX);

int SetupTTY(
      ttyDime * DIM,
      char **VideoModeList,
      char *dev_console,
      char *dev_mouse,
      char **argv
    );
int CloseTTY(ttyDime *DIM);
int a4cLoadModules(ttyDime *DIM);
int a4cFreeModules(ttyDime *DIM);
int UnifyCharset(ttyDime *DIM,char *str);

#define TTY_EVENT_MICE_TERM      0x001
#define TTY_EVENT_MICE_MENU      0x002
#define TTY_EVENT_MICE_METHOD    0x003
#define TTY_EVENT_MICE_CHARSET   0x004
#define TTY_EVENT_MICE_FONTSIZE  0x005
#define TTY_EVENT_MICE_SCROLL    0x006
#define TTY_EVENT_MICE_LISTAREA  0x007
#define TTY_EVENT_MICE_KEYAREA   0x008

#define TTY_EVENT_KEYPRESS       0x100
#define TTY_EVENT_VTMSG          0x101

int ttyNextEvent(ttyDime *DIM);
void ttyDrawMenuButton(ttyDime *DIM,int up_down);
void ttyDrawPanel(ttyDime *DIM);


#endif

